package com.ruoyi.analysis.config;


import com.ruoyi.analysis.constants.HBaseConstant;
import com.ruoyi.analysis.hbase.service.impl.HBaseServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.stereotype.Component;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 *启动判断当前日期创建表
 */
@Component
public class RunnerAfter implements ApplicationRunner {
    @Autowired
    private HBaseServiceImpl hBaseServiceImpl;

    @Override
    public void run(ApplicationArguments args) throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        String nowDay = sdf.format(new Date());
        //项目启动时根据当前日期判断是否创建表
        if(!hBaseServiceImpl.isTableExists(HBaseConstant.HBASE_TABLE_PREFIX+nowDay)){
            hBaseServiceImpl.createTable(HBaseConstant.HBASE_TABLE_PREFIX+nowDay,new String[]{"analysis"});
        }
    }
}
