package com.ruoyi.analysis.config;


import com.ruoyi.analysis.constants.HBaseConstant;
import com.ruoyi.analysis.hbase.service.impl.HBaseServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * 定时每日创建表重新赋值新表地址
 */
@Component
public class TimeConfig {
    @Autowired
    private HBaseServiceImpl hBaseServiceImpl;
    private SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");


    @Scheduled(cron = "0 0 0 * * ?")
    public void flushNowDay() throws IOException {
        String nowDay = sdf.format(new Date());
        //判断表是否存在
        if(!hBaseServiceImpl.isTableExists(HBaseConstant.HBASE_TABLE_PREFIX+nowDay)){
            //不存在创建表
            hBaseServiceImpl.createTable(HBaseConstant.HBASE_TABLE_PREFIX+nowDay,new String[]{"analysis"});
        }
    }
}
