package com.ruoyi.analysis.handler;

import com.ruoyi.analysis.domain.VehicleMessage;
import lombok.extern.log4j.Log4j2;

/**
 * 报文格式分割
 */
@Log4j2
public class MessageHandler {

  /**
   *根据转译对数据进行封装实体类
   */
  public static VehicleMessage messageTranslated(String content){
        //创建对象
      VehicleMessage vehicleMessage=new VehicleMessage();

        //消息标识
        vehicleMessage.setIdentification(content.substring(0, 12));

        //VIN码
        vehicleMessage.setVinCode(content.substring(12,29));

        //经度
        vehicleMessage.setLongitude(content.substring(29,40));

        //纬度
        vehicleMessage.setLatitude(content.substring(40,50));

        //车速
        vehicleMessage.setSpeedOfVehicle(content.substring(50,56));

        //总里程
        vehicleMessage.setTotalMileage(content.substring(56,67));

        //总电压
        vehicleMessage.setTotalVoltage(content.substring(67,73));

        //总电流
        vehicleMessage.setCombinedCurrent(content.substring(73,78));

        //绝缘电阻
        vehicleMessage.setInsulationResistance(content.substring(78,87));

        //档位
        vehicleMessage.setGearPosition(content.substring(87,88));

        //加速踏板行程值
        vehicleMessage.setAcceleratorPedalTravelValue(content.substring(88,90));

        //制动踏板行程值
        vehicleMessage.setBrakePedalTravelValue(content.substring(90,92));

        //燃料消耗率
        vehicleMessage.setSpecificFuelConsumption(content.substring(92,97));

        //电机控制器温度
        vehicleMessage.setMotorControllerTemperature(content.substring(97,103));

        //电机转速
        vehicleMessage.setMotorSpeed(content.substring(103,108));

        //电机转矩
        vehicleMessage.setMotorTorque(content.substring(108,112));

        //电机温度
        vehicleMessage.setMotorTemperature(content.substring(112,118));

        //电机电压
        vehicleMessage.setMotorVoltage(content.substring(118,123));

        //电机电流
        vehicleMessage.setMotorCurrent(content.substring(123,131));

        //动力电池剩余电量SOC
        vehicleMessage.setElectricalSoc(content.substring(131,137));

        //当前状态允许的最大反馈功率
        vehicleMessage.setMaximumFeedbackPower(content.substring(137,143));

        //当前状态允许最大放电功率
        vehicleMessage.setMaximumDischargePower(content.substring(143,149));

        //BMS自检计数器
        vehicleMessage.setBms(content.substring(149,151));

        //动力电池充放电电流
        vehicleMessage.setBatteryCurrent(content.substring(151,156));

        //动力电池负载端总电压V3
        vehicleMessage.setV3(content.substring(156,162));

        //单次最大电压
        vehicleMessage.setSingleMaximumVoltage(content.substring(162,165));

        //单体电池最低电压
        vehicleMessage.setMinimumVoltageOfBattery(content.substring(165,170));

        //单体电池最高温度
        vehicleMessage.setMaximumBatteryTemperature(content.substring(170,176));

        //单体电池最低温度
        vehicleMessage.setMinimumBatteryTemperature(content.substring(176,182));

        //动力电池可用容量
        vehicleMessage.setPowerBatteryAvailableCapacity(content.substring(182,188));

        //车辆状态
        vehicleMessage.setCarStatus(Integer.valueOf(content.substring(188,189)));

        //充电状态
        vehicleMessage.setChargingState(Integer.valueOf(content.substring(189,190)));

        //运行状态
        vehicleMessage.setRunningState(Integer.valueOf(content.substring(190,191)));

        //SOC
        vehicleMessage.setSoc(content.substring(191,192));

        //可充电储能装置工作状态
        vehicleMessage.setWorkingCondition(content.substring(192,193));

        //驱动电机状态
        vehicleMessage.setDriveMotorCondition(content.substring(193,194));

        //定位是否有效
        vehicleMessage.setWhetherTheLocationValid(content.substring(194,195));

        //EAS
        vehicleMessage.setEas(content.substring(195,196));

        //PTC
        vehicleMessage.setPtc(content.substring(196,197));

        //EPS
        vehicleMessage.setEps(content.substring(197,198));

        //ABS
        vehicleMessage.setAbs(content.substring(198,199));

        //MCU
        vehicleMessage.setMcu(content.substring(199,200));

        //动力电池加热状态
        vehicleMessage.setPowerBatteryHeatingState(content.substring(200,201));

        //动力电池当前状态
        vehicleMessage.setPowerBattery(content.substring(201,202));

        //动力电池保温状态
        vehicleMessage.setPowerBatteryInsulationState(content.substring(202,203));

        //DCDC
        vehicleMessage.setDcdc(content.substring(203,204));

        //CHG
        vehicleMessage.setChg(content.substring(204,205));

        //时间
        vehicleMessage.setTime(Long.valueOf(content.substring(205,218)));

        return vehicleMessage;

    }

}
