package com.ruoyi.analysis.handler;

import com.ruoyi.analysis.constants.VehicleConstant;
import org.apache.commons.lang3.StringUtils;

/**
 * 报文转换
 */
public class MessageVerify {


    /**
     * 检测报文是否合法
     */
    public static boolean checkMessageHandler(String message){
        if(!message.contains(VehicleConstant.DATA_PACK_SEPARATOR)){
            return false;
        }
        String temp = message.replaceAll("#\\$&\\*","");
        if(message.indexOf(VehicleConstant.MSG_START) !=0) return false;
        if((message.lastIndexOf(VehicleConstant.MSG_END)+2) != temp.length()) return false;
        String content = message.substring(2,message.length()-9);
        String data = content.replace(" ", "");
        int dSum = 0;
        int length = data.length();
        int index = 0;
        // 遍历十六进制，并计算总和
        while (index < length) {
            // 截取2位字符
            String s = data.substring(index, index + 2);
            // 十六进制转成十进制 , 并计算十进制的总和
            dSum += Integer.parseInt(s, 16);
            index = index + 2;
        }
        // 用256取余，十六进制最大是FF，FF的十进制是255
        int mod = dSum % 256;
        // 余数转成十六进制
        String checkSumHex = Integer.toHexString(mod);
        length = checkSumHex.length();
        if (length < 2) {
            // 校验位不足两位的，在前面补0
            checkSumHex = "0" + checkSumHex;
        }
        String parityBit = message.substring(message.length() - 9,message.length() - 7);
        return parityBit.equals(checkSumHex);
    }


    /**
     * 将16进制数据转为字符
     */
    public static String theDecimal(String hexString){
        String[] split = hexString.split(" ");
        StringBuilder stringBuilder = new StringBuilder();
        for (String info : split) {
            if(StringUtils.isNotEmpty(info)){
                String decimalTemp = valueToAscii(Integer.valueOf(info, 16).toString());
                stringBuilder.append(decimalTemp);
            }
        }
        return stringBuilder.toString();
    }

    /**
     * 将10进制数据转为字符
     */
    public static String valueToAscii(String value){
        StringBuilder builder = new StringBuilder();
        String[] chars = value.split(",");
        for (String info : chars) {
            builder.append((char)Integer.parseInt(info));
        }
        return builder.toString();
    }
}
