package com.ruoyi.analysis.hbase.config;


import com.ruoyi.analysis.hbase.exception.HBaseException;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Configuration;

import java.util.Map;

/**
 * Hbase配置类
 */

@Configuration
@ConfigurationProperties(prefix = HbaseConfig.CONF_PREFIX)
public class HbaseConfig {
    /**
     * 配置文件前缀
     */
    public static final String CONF_PREFIX = "hbase.conf";

    private Map<String,String> confMaps;

    public Map<String, String> getConfMaps() {
        if(confMaps == null){
            throw new HBaseException("请配置：[hbase.conf.confMaps.zookeeper.quorum]");
        }
        return confMaps;
    }

    /**
     * 将配置映射给当前对象
     */
    public void setConfMaps(Map<String, String> confMaps) {
        this.confMaps = confMaps;
    }
}
