package com.ruoyi.analysis.kafka.config;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Configuration;

/**
 * kafka消费者配置
 */
@Data
@Configuration
@ConfigurationProperties(prefix = "kafka.consumer")
public class ConsumerCustomConfig {
    /**
     *消费者
     */
    public String group;
    /**
     * 主题
     */
    public String topic;
    /**
     * 分区
     */
    public int partitions;
    /**
     * 等待时间
     */
    private long waitingTime=1000;
}
